
% Solves the ``retired block'' fixed point problem and backs-out the
% remaining value functions
% Recovered
R_r = (param.b_re+param.chi)/(param.r + param.chi);

% Values that depend on the infection ratio
% The death rate
gamma_o_min = param.gamma_o*max(li./param.Theta, 1);

% Infected
R_i = ( param.b_re + (param.chi + gamma_o_min) +param.rho_o*R_r )./ ...
    (param.r + param.chi + gamma_o_min +param.rho_o);

% Susceptible

R_s = ( param.b_re + param.chi + param.lambda_o*li.*R_i )./ ...
    (param.r + param.chi + param.lambda_o*li );

if aux.lockdown==1
    R_i_L = R_i;
    R_s_L = (param.b_re + param.chi + param.lambda_o_ld*li.*R_i_L + param.Lambda*R_s ) ./ ...
        (param.r + param.chi + param.lambda_o_ld*li + param.Lambda);
end












 