%%%%%% update the mean wage in a state %%%%%%%

if locked(t)==0
    % If the lockdown is ending
    if t>1
        if locked(t-1)==1

            %Take the weighted average after the end of lockdown
       
            s0_tot     =  es0(:,t) + es0_L_ld(:,t);
            ws0(:,t)        = (es0(:,t))./(s0_tot + (s0_tot < mass_thresh)*(1)).*ws0(:,t) + (es0_L_ld(:,t))./(s0_tot + (s0_tot < mass_thresh)*(1)).*ws0_L_ld(:,t);
            ws0(:,t)        =  ws0(:,t).*(s0_tot >= mass_thresh) + (-99)*(s0_tot < mass_thresh);
            ws0_L_ld(:,t)   = zeros(aux.x_grid*aux.alpha_grid,1);

            s1_tot(:,t)     =  es1(:,t) + es1_L_ld(:,t);
            ws1(:,t)        = (es1(:,t))./(s1_tot(:,t) + (s1_tot(:,t) < mass_thresh)*(1)).*ws1(:,t) + (es1_L_ld(:,t))./(s1_tot(:,t) + (s1_tot(:,t) < mass_thresh)*(1)).*ws1_L_ld(:,t);
            ws1(:,t)        = ws1(:,t).*(s1_tot(:,t) >= mass_thresh) + (-99)*(s1_tot(:,t) < mass_thresh);
            ws1_L_ld(:,t)   = zeros(aux.x_grid*aux.alpha_grid,1);


            i_tot(:,t)      = ei(:,t) + ei_L_ld(:,t);
            wi(:,t)         = (ei(:,t))./(i_tot(:,t) + (i_tot(:,t) < mass_thresh)*(1)).*wi(:,t)  + (ei_L_ld(:,t))./(i_tot(:,t) + (i_tot(:,t) < mass_thresh)*(1)).*wi_L_ld(:,t);
            wi(:,t)         = wi(:,t).*(i_tot(:,t) >= mass_thresh) + (-99)*(i_tot(:,t) < mass_thresh);
            wi_L_ld(:,t)    = zeros(aux.x_grid*aux.alpha_grid,1);


            r_tot      = er(:,t) + er_L_ld(:,t);
            wr(:,t)         = (er(:,t))./(r_tot + (r_tot < mass_thresh)*(1)).*wr(:,t)  + (er_L_ld(:,t))./(r_tot + (r_tot < mass_thresh)*(1)).*wr_L_ld(:,t);
            wr_L_ld(:,t)    = zeros(aux.x_grid*aux.alpha_grid,1);

        end
    end
    clear s0_tot s1_tot i_tot r_tot

     % First incumbents who renegotiate their wage
    ws0_incumb = ws0(:,t).*(exp(-aux.dt*param.nu*(Ss_t >=0).*(Ss0_t > Ss1_t))) ... 
         + (1 - exp(-aux.dt*param.nu*(Ss_t >=0).*(Ss0_t > Ss1_t))).* wage_s0(:,grid);
    ws0_incumb = ws0_incumb.*(es0(:,t)>=mass_thresh) - 99*(es0(:,t)< mass_thresh) ; 

    ws1_incumb = ws1(:,t).*(exp(-aux.dt*param.nu*(Ss_t >=0).*(Ss1_t >= Ss0_t))) ... 
         + (1 - exp(-aux.dt*param.nu*(Ss_t >=0).*(Ss1_t >= Ss0_t))).* wage_s1(:,grid);
    ws1_incumb = ws1_incumb.*(es1(:,t)>=mass_thresh) - 99*(es1(:,t)<mass_thresh) ;

    wi_incumb = wi(:,t).*(exp(-aux.dt*param.nu*(Si_t >= 0))) ...
        + (1 - exp(-aux.dt*param.nu*(Si_t >= 0))).* wage_i(:,grid);
    wi_incumb = wi_incumb.*(ei(:,t)>=mass_thresh) - 99*(ei(:,t)<mass_thresh) ;

    wr_incumb = wr(:,t).*(exp(-aux.dt*param.nu*(Sr_t >= 0))) ...
        + (1 - exp(-aux.dt*param.nu*(Sr_t >= 0))).* wage_r(:,grid);
    wr_incumb = wr_incumb.*(er(:,t)>=mass_thresh) - 99*(er(:,t)<mass_thresh) ;

    %%%

    % Updating. 
    s0_inc = (es0(:,t) - (1- exp(-aux.dt*(param.delta + param.eta)*es0(:,t))) ...
        - (1- exp(-aux.dt*param.nu*es0(:,t).*(Ss_t < 0))) ...
        - (1- exp(-aux.dt*param.nu*es0(:,t).*(Ss_t >=0).*(Ss1_t >= Ss0_t))) ...
        - (1- exp(-aux.dt*es0(:,t)*param.lambda_0y*ell(t))));
    s0_new = ((1- exp(-aux.dt*us(t)*phi_t*(Ss0_t > Ss1_t).*(Ss_t >= 0).*f)) ... 
        + (1- exp(-aux.dt*param.nu*es1(:,t).*(Ss_t >= 0).*(Ss1_t < Ss0_t))));
    s0_tot = s0_inc + s0_new;
    ws0(:,t+1) = (s0_inc.*ws0_incumb + s0_new.*wage_s0(:,grid))./(s0_tot + (s0_tot < mass_thresh)*(1)).*((s0_tot >= mass_thresh) + (-4000000)*(s0_tot < mass_thresh));
    ws0(:,t+1) = ws0(:,t+1).*(s0_tot >= mass_thresh) + (-99)*(s0_tot < mass_thresh);    
    clear s0_inc s0_new s0_tot

    s1_inc = (es1(:,t) - (1- exp(-aux.dt*(param.delta + param.eta)*es1(:,t))) ...
        - (1- exp(-aux.dt*param.nu*es1(:,t).*(Ss_t < 0))) ...
        - (1- exp(-aux.dt*param.nu*es1(:,t).*(Ss_t >=0).*(Ss1_t < Ss0_t))) ...
        - (1- exp(-aux.dt*es1(:,t)*(param.lambda_0y + param.lambda_1y)*ell(t))));        
    s1_new = ((1- exp(-aux.dt*us(t)*phi_t*(Ss0_t <= Ss1_t).*(Ss_t >= 0).*f)) ... 
        + (1- exp(-aux.dt*param.nu*es0(:,t).*(Ss_t >= 0).*(Ss1_t >= Ss0_t))));
    s1_tot = s1_inc + s1_new;
    ws1(:,t+1) = (s1_inc.*ws1_incumb + s1_new.*wage_s1(:,grid))./(s1_tot + (s1_tot < mass_thresh)*(1)).*((s1_tot >= mass_thresh) + (-4000000)*(s1_tot < mass_thresh));
    ws1(:,t+1) = ws1(:,t+1).*(s1_tot >= mass_thresh) + (-99)*(s1_tot < mass_thresh);   
    clear s1_inc s1_new s1_tot

    si_inc = (ei(:,t) - (1- exp(-aux.dt*param.nu*ei(:,t).*(Si_t < 0))) ...
                - (1- exp(-aux.dt*(param.delta + param.rho_y + gamma_y_t + param.eta)*ei(:,t))));      
    si_new = (1- exp(-aux.dt*es0(:,t)*param.lambda_0y*ell(t))) + (1- exp(-aux.dt*es1(:,t).*(param.lambda_0y + param.lambda_1y)*ell(t)));
    si_tot = si_inc + si_new;
    wi(:,t+1) = (si_inc.*wi_incumb + (1- exp(-aux.dt*es0(:,t)*param.lambda_0y*ell(t))).*ws0(:,t) ...
        + (1- exp(-aux.dt*es1(:,t).*(param.lambda_0y + param.lambda_1y)*ell(t))).*ws1(:,t))./(si_tot + (si_tot < mass_thresh)*(1)).*((si_tot >= mass_thresh) + (-4000000)*(si_tot < mass_thresh)); 
    wi(:,t+1) = wi(:,t+1).*(si_tot >= mass_thresh) + (-99)*(si_tot < mass_thresh);    
    clear si_inc si_new si_tot

    sr_inc = (er(:,t) - (1- exp(-aux.dt*(param.delta + param.eta)*er(:,t))) - (1- exp(-aux.dt*param.nu*er(:,t).*(Sr_t < 0))));
    sr_new = (1- exp(-aux.dt*param.rho_y*ei(:,t))) + (1- exp(-aux.dt*ur(t)*phi_t*(Sr_t >= 0).*f));
    sr_tot = sr_inc + sr_new;
    wr(:,t+1) = (sr_inc.*wr_incumb + (1- exp(-aux.dt*param.rho_y*ei(:,t))).*wi(:,t) ...
        + (1- exp(-aux.dt*ur(t)*phi_t*(Sr_t >= 0).*f)).*wage_r(:,grid))./(sr_tot + (sr_tot < mass_thresh)*(1)).*((sr_tot >= mass_thresh) + (-4000000)*(sr_tot < mass_thresh)); 
    wr(:,t+1) = wr(:,t+1).*(sr_tot >= mass_thresh) + (-99)*(sr_tot < mass_thresh);    
    clear sr_inc sr_new sr_tot

elseif locked(t)==1
    if locked(t-1)==0
        %workers inheret previous wages at the start of lockdown
        ws0_L_ld(:,t) = ws0(:,t);
        ws1_L_ld(:,t) = ws1(:,t);
        wi_L_ld(:,t) = wi(:,t);
        wr_L_ld(:,t) = wr(:,t);
     
    end
    
     % Incumbent wages 
    ws0_L_ld_incumb = ws0_L_ld(:,t).*(exp(-aux.dt*param.nu*(Ss_L_ld_t >=0).*(Ss1_L_ld_t < Ss0_L_ld_t))) ...
        + (1-exp(-aux.dt*param.nu*(Ss_L_ld_t >=0).*(Ss1_L_ld_t < Ss0_L_ld_t))).*wage_s0_L_ld(:,grid);
    ws0_L_ld_incumb = ws0_L_ld_incumb.*(es0_L_ld(:,t) >= mass_thresh) - 99*(es0_L_ld(:,t) < mass_thresh);

    ws0_U_ld_incumb = ws0(:,t).*(exp(-aux.dt*param.nu*(Ss_U_ld_t >=0).*(Ss1_U_ld_t < Ss0_U_ld_t))) ...
        + (1-exp(-aux.dt*param.nu*(Ss_U_ld_t >=0).*(Ss1_U_ld_t < Ss0_U_ld_t))).*wage_s0_U_ld(:,grid);
    ws0_U_ld_incumb = ws0_U_ld_incumb.*(es0(:,t) >= mass_thresh) - 99*(es0(:,t) < mass_thresh);

    ws1_L_ld_incumb = ws1_L_ld(:,t).*(exp(-aux.dt*param.nu*(Ss_L_ld_t >=0).*(Ss1_L_ld_t >= Ss0_L_ld_t))) ...
        + (1-exp(-aux.dt*param.nu*(Ss_L_ld_t >=0).*(Ss1_L_ld_t >= Ss0_L_ld_t))).*wage_s1_L_ld(:,grid);
    ws1_L_ld_incumb = ws1_L_ld_incumb.*(es1_L_ld(:,t) >= mass_thresh) - 99*(es1_L_ld(:,t) < mass_thresh);

    ws1_U_ld_incumb = ws1(:,t).*(exp(-aux.dt*param.nu*(Ss_U_ld_t >=0).*(Ss1_U_ld_t >= Ss0_U_ld_t))) ...
        + (1-exp(-aux.dt*param.nu*(Ss_U_ld_t >=0).*(Ss1_U_ld_t >= Ss0_U_ld_t))).*wage_s1_U_ld(:,grid);
    ws1_U_ld_incumb = ws1_U_ld_incumb.*(es1(:,t) >= mass_thresh) - 99*(es1(:,t) < mass_thresh);

    wi_L_ld_incumb = wi_L_ld(:,t).*(exp(-aux.dt*param.nu*(Si_L_ld_t >= 0))) ...
        + (1- exp(-aux.dt*param.nu*(Si_L_ld_t >= 0))).*wage_i_L_ld(:,grid);
    wi_L_ld_incumb = wi_L_ld_incumb.*(ei_L_ld(:,t) >= mass_thresh) - 99*(ei_L_ld(:,t) < mass_thresh);    

    wi_U_ld_incumb = wi(:,t).*(exp(-aux.dt*param.nu*(Si_U_ld_t >= 0))) ...
        + (1- exp(-aux.dt*param.nu*(Si_U_ld_t >= 0))).*wage_i_U_ld(:,grid);
    wi_U_ld_incumb = wi_U_ld_incumb.*(ei(:,t) >= mass_thresh) - 99*(ei(:,t) < mass_thresh);       

    wr_L_ld_incumb = wr_L_ld(:,t).*(exp(-aux.dt*param.nu*(Sr_L_ld_t >= 0))) ...
        + (1- exp(-aux.dt*param.nu*(Sr_L_ld_t >= 0))).*wage_r_L_ld(:,grid);
    wr_L_ld_incumb = wr_L_ld_incumb.*(er_L_ld(:,t) >= mass_thresh) - 99*(er_L_ld(:,t) < mass_thresh);      

    wr_U_ld_incumb = wr(:,t).*(exp(-aux.dt*param.nu*(Sr_U_ld_t >= 0))) ...
        + (1- exp(-aux.dt*param.nu*(Sr_U_ld_t >= 0))).*wage_r_U_ld(:,grid);
    wr_U_ld_incumb = wr_U_ld_incumb.*(er(:,t) >= mass_thresh) - 99*(er(:,t) < mass_thresh); 

    %%%%

    % New guys' wage
    s0_L_ld_inc = (es0_L_ld(:,t) - (1- exp(-aux.dt*(param.delta + param.eta)*es0_L_ld(:,t))) ...
        - (1- exp(-aux.dt*param.nu*es0_L_ld(:,t).*(Ss_L_ld_t < 0))) ...
        - (1- exp(-aux.dt*param.nu*es0_L_ld(:,t).*(Ss_L_ld_t >=0).*(Ss1_L_ld_t >= Ss0_L_ld_t))) ...
        - (1- exp(-aux.dt*es0_L_ld(:,t)*param.lambda_0y_ld*ell(t))));
    s0_L_ld_new = (1- exp(-aux.dt*param.pi*us(t)*phi_t*(Ss0_L_ld_t > Ss1_L_ld_t).*(Ss_L_ld_t >= 0).*f)) ...
         + (1- exp(-aux.dt*param.nu*es1_L_ld(:,t).*(Ss_L_ld_t >= 0).*(Ss1_L_ld_t < Ss0_L_ld_t)));
    s0_L_ld_tot = s0_L_ld_inc + s0_L_ld_new;

    ws0_L_ld(:,t+1) = (s0_L_ld_inc.*ws0_L_ld_incumb + s0_L_ld_new.*wage_s0_L_ld(:,grid))./(s0_L_ld_tot + (s0_L_ld_tot<mass_thresh)*(1)).* ...
        ((s0_L_ld_tot >= mass_thresh) + (-4000000)*(s0_L_ld_tot < mass_thresh));
    ws0_L_ld(:,t+1) = ws0_L_ld(:,t+1).*(s0_L_ld_tot >= mass_thresh) + (-99)*(s0_L_ld_tot < mass_thresh);

    clear s0_L_ld_inc s0_L_ld_new s0_L_ld_tot 

    s1_L_ld_inc = (es1_L_ld(:,t) - (1- exp(-aux.dt*(param.delta + param.eta)*es1_L_ld(:,t))) ...
        - (1- exp(-aux.dt*param.nu*es1_L_ld(:,t).*(Ss_L_ld_t < 0))) ...
        - (1- exp(-aux.dt*param.nu*es1_L_ld(:,t).*(Ss_L_ld_t >=0).*(Ss1_L_ld_t < Ss0_L_ld_t))) ...
        - (1- exp(-aux.dt*es1_L_ld(:,t)*(param.lambda_0y_ld)*ell(t)))); 
    s1_L_ld_new = (1- exp(-aux.dt*param.pi*us(t)*phi_t*(Ss0_L_ld_t <= Ss1_L_ld_t).*(Ss_L_ld_t >= 0).*f)) ...
         + (1- exp(-aux.dt*param.nu*es0_L_ld(:,t).*(Ss_L_ld_t >= 0).*(Ss1_L_ld_t >= Ss0_L_ld_t)));
    s1_L_ld_tot = s1_L_ld_inc + s1_L_ld_new;

    ws1_L_ld(:,t+1) = (s1_L_ld_inc.*ws1_L_ld_incumb + s1_L_ld_new.*wage_s1_L_ld(:,grid))./(s1_L_ld_tot + (s1_L_ld_tot<mass_thresh)*(1)).* ...
        ((s1_L_ld_tot >= mass_thresh) + (-4000000)*(s1_L_ld_tot < mass_thresh));
    ws1_L_ld(:,t+1) = ws1_L_ld(:,t+1).*(s1_L_ld_tot >= mass_thresh) + (-99)*(s1_L_ld_tot < mass_thresh);

    clear s1_L_ld_inc s1_L_ld_new s1_L_ld_tot 

    s0_U_ld_inc = (es0(:,t) - (1- exp(-aux.dt*(param.delta + param.eta)*es0(:,t))) ...
        - (1- exp(-aux.dt*param.nu*es0(:,t).*(Ss_U_ld_t < 0))) ...
        - (1- exp(-aux.dt*param.nu*es0(:,t).*(Ss_U_ld_t >=0).*(Ss1_U_ld_t >= Ss0_U_ld_t))) ...
        - (1- exp(-aux.dt*es0(:,t)*param.lambda_0y_ld*ell(t))));
    s0_U_ld_new = (1- exp(-aux.dt*(1-param.pi)*us(t)*phi_t*(Ss0_U_ld_t > Ss1_U_ld_t).*(Ss_U_ld_t >= 0).*f)) ...
         + (1- exp(-aux.dt*param.nu*es1(:,t).*(Ss_U_ld_t >= 0).*(Ss1_U_ld_t < Ss0_U_ld_t)));
    s0_U_ld_tot = s0_U_ld_inc + s0_U_ld_new;
    ws0(:,t+1) = (s0_U_ld_inc.*ws0_U_ld_incumb + s0_U_ld_new.*wage_s0_U_ld(:,grid))./(s0_U_ld_tot + (s0_U_ld_tot<mass_thresh)*(1)).* ...
        ((s0_U_ld_tot >= mass_thresh) + (-4000000)*(s0_U_ld_tot < mass_thresh));
    ws0(:,t+1) = ws0(:,t+1).*(s0_U_ld_tot >= mass_thresh) + (-99)*(s0_U_ld_tot < mass_thresh);

    clear s0_U_ld_inc s0_U_ld_new s0_U_ld_tot 

    s1_U_ld_inc = (es1(:,t) - (1- exp(-aux.dt*(param.delta + param.eta)*es1(:,t))) ...
        - (1- exp(-aux.dt*param.nu*es1(:,t).*(Ss_U_ld_t < 0))) ...
        - (1- exp(-aux.dt*param.nu*es1(:,t).*(Ss_U_ld_t >=0).*(Ss1_U_ld_t < Ss0_U_ld_t))) ...
        - (1- exp(-aux.dt*es1(:,t)*(param.lambda_0y_ld + param.lambda_1y)*ell(t))));
    s1_U_ld_new = (1- exp(-aux.dt*(1-param.pi)*us(t)*phi_t*(Ss0_U_ld_t <= Ss1_U_ld_t).*(Ss_U_ld_t >= 0).*f)) ...
         + (1- exp(-aux.dt*param.nu*es0(:,t).*(Ss_U_ld_t >= 0).*(Ss1_U_ld_t >= Ss0_U_ld_t)));
    s1_U_ld_tot = s1_U_ld_inc + s1_U_ld_new;
    ws1(:,t+1) = (s1_U_ld_inc.*ws1_U_ld_incumb + s1_U_ld_new.*wage_s1_U_ld(:,grid))./(s1_U_ld_tot + (s1_U_ld_tot<mass_thresh)*(1)).* ...
        ((s1_U_ld_tot >= mass_thresh) + (-4000000)*(s1_U_ld_tot < mass_thresh));
    ws1(:,t+1) = ws1(:,t+1).*(s1_U_ld_tot >= mass_thresh) + (-99)*(s1_U_ld_tot < mass_thresh);

    clear s1_U_ld_inc s1_U_ld_new s1_U_ld_tot 

    si_L_ld_inc = (ei_L_ld(:,t) - (1- exp(-aux.dt*param.nu*ei_L_ld(:,t).*(Si_L_ld_t < 0))) ...
        - (1- exp(-aux.dt*(param.delta + param.rho_y + gamma_y_t + param.eta)*ei_L_ld(:,t))));
    si_L_ld_new = (1- exp(-aux.dt*es0_L_ld(:,t)*param.lambda_0y_ld*ell(t))) ...
        + (1- exp(-aux.dt*es1_L_ld(:,t)*param.lambda_0y_ld*ell(t)));
    si_L_ld_tot = si_L_ld_inc + si_L_ld_new;
    wi_L_ld(:,t+1) = (si_L_ld_inc.*wi_L_ld_incumb + (1- exp(-aux.dt*es0_L_ld(:,t)*param.lambda_0y_ld*ell(t))).*ws0_L_ld(:,t) ...
        + (1- exp(-aux.dt*es1_L_ld(:,t)*param.lambda_0y_ld*ell(t))).*ws1_L_ld(:,t))./(si_L_ld_tot + (si_L_ld_tot < mass_thresh)*(1)).* ...
        ((si_L_ld_tot >= mass_thresh) + (-4000000)*(si_L_ld_tot < mass_thresh));
    wi_L_ld(:,t+1) = wi_L_ld(:,t+1).*(si_L_ld_tot >= mass_thresh) + (-99)*(si_L_ld_tot < mass_thresh);

    clear si_L_ld_inc si_L_ld_new si_L_ld_tot

    si_U_ld_inc = (ei(:,t) - (1- exp(-aux.dt*param.nu*ei(:,t).*(Si_U_ld_t < 0))) ...
        - (1- exp(-aux.dt*(param.delta + param.rho_y + gamma_y_t + param.eta)*ei(:,t))));
    si_U_ld_new = (1- exp(-aux.dt*es0(:,t)*param.lambda_0y_ld*ell(t))) ...
        + (1- exp(-aux.dt*es1(:,t)*(param.lambda_0y_ld + param.lambda_1y)*ell(t)));
    si_U_ld_tot = si_U_ld_inc + si_U_ld_new;
    wi(:,t+1) = (si_U_ld_inc.*wi_U_ld_incumb + (1- exp(-aux.dt*es0(:,t)*param.lambda_0y_ld*ell(t))).*ws0(:,t) ...
        + (1- exp(-aux.dt*es1(:,t)*(param.lambda_0y_ld + param.lambda_1y)*ell(t))).*ws1(:,t))./(si_U_ld_tot + (si_U_ld_tot < mass_thresh)*(1)).* ...
        ((si_U_ld_tot >= mass_thresh) + (-4000000)*(si_U_ld_tot < mass_thresh));
    wi(:,t+1) = wi(:,t+1).*(si_U_ld_tot >= mass_thresh) + (-99)*(si_U_ld_tot < mass_thresh);

    clear si_L_ld_inc si_L_ld_new si_L_ld_tot

    sr_L_ld_inc = (er_L_ld(:,t) - (1- exp(-aux.dt*(param.delta + param.eta)*er_L_ld(:,t))) ...
        - (1- exp(-aux.dt*param.nu*er_L_ld(:,t).*(Sr_L_ld_t < 0))));
    sr_L_ld_new = (1- exp(-aux.dt*ur(t)*param.pi*phi_t*(Sr_L_ld_t >= 0).*f)) ...
        + (1- exp(-aux.dt*param.rho_y*ei_L_ld(:,t)));
    sr_L_ld_tot = sr_L_ld_inc + sr_L_ld_new;
    wr_L_ld(:,t+1) = (sr_L_ld_inc.*wr_L_ld_incumb + (1- exp(-aux.dt*ur(t)*param.pi*phi_t*(Sr_L_ld_t >= 0).*f)).*wage_r_L_ld(:,grid) ...
        + (1- exp(-aux.dt*param.rho_y*ei_L_ld(:,t))).*wi_L_ld(:,t))./(sr_L_ld_tot + (sr_L_ld_tot < mass_thresh)*(1)).* ...
        ((sr_L_ld_tot >= mass_thresh) + (-4000000)*(sr_L_ld_tot < mass_thresh));
    wr_L_ld(:,t+1) = wr_L_ld(:,t+1).*(sr_L_ld_tot >= mass_thresh) + (-99)*(sr_L_ld_tot < mass_thresh);

    clear sr_L_ld_inc sr_L_Ld_new sr_L_ld_tot

    sr_U_ld_inc = (er(:,t) - (1- exp(-aux.dt*(param.delta + param.eta)*er(:,t))) ...
        - (1- exp(-aux.dt*param.nu*er(:,t).*(Sr_U_ld_t < 0))));
    sr_U_ld_new = (1- exp(-aux.dt*ur(t)*(1-param.pi)*phi_t*(Sr_U_ld_t >= 0).*f)) ...
        + (1- exp(-aux.dt*param.rho_y*ei(:,t)));
    sr_U_ld_tot = sr_U_ld_inc + sr_U_ld_new;

    wr(:,t+1) = (sr_U_ld_inc.*wr_U_ld_incumb + (1- exp(-aux.dt*ur(t)*(1-param.pi)*phi_t*(Sr_U_ld_t >= 0).*f)).*wage_r_U_ld(:,grid) ...
        + (1- exp(-aux.dt*param.rho_y*ei(:,t))).*wi(:,t))./(sr_U_ld_tot + (sr_U_ld_tot < mass_thresh)*(1)).* ...
        ((sr_U_ld_tot >= mass_thresh) + (-4000000)*(sr_U_ld_tot < mass_thresh));
    wr(:,t+1) = wr(:,t+1).*(sr_U_ld_tot >= mass_thresh) + (-99)*(sr_U_ld_tot < mass_thresh);

    clear sr_U_ld_inc sr_U_ld_new sr_U_ld_tot
end
        