if locked(t)==0
 
    if t>1
        if locked(t-1)==1
            

            %Take the weighted average after the end of lockdown
            
            s0_tot     =  es0(:,t) + es0_L_ld(:,t) + (Ss0_t>Ss1_t).*es2_L_ld(:,t)  + (Ss0_t>Ss1_t).*es2(:,t);
            ws0(:,t)        = (es0(:,t))./(s0_tot + (s0_tot < mass_thresh)*(1)).*ws0(:,t) + (es0_L_ld(:,t))./(s0_tot + (s0_tot < mass_thresh)*(1)).*ws0_L_ld(:,t) ...
                + ((Ss0_t>Ss1_t).*es2(:,t))./(s0_tot + (s0_tot < mass_thresh)*(1)).*ws2(:,t) + ((Ss0_t>Ss1_t).*es2_L_ld(:,t))./(s0_tot + (s0_tot < mass_thresh)*(1)).*ws2_L_ld(:,t);
            ws0(:,t)        =  ws0(:,t).*(s0_tot >= mass_thresh) + (-99)*(s0_tot < mass_thresh);



            s1_tot     =  es1(:,t) + es1_L_ld(:,t) + (Ss1_t>=Ss0_t).*es2_L_ld(:,t) + (Ss1_t>=Ss0_t).*es2(:,t);
            ws1(:,t)        = (es1(:,t))./(s1_tot + (s1_tot < mass_thresh)*(1)).*ws1(:,t) + (es1_L_ld(:,t))./(s1_tot + (s1_tot < mass_thresh)*(1)).*ws1_L_ld(:,t) ...
               + ((Ss1_t>=Ss0_t).*es2(:,t))./(s1_tot + (s1_tot < mass_thresh)*(1)).*ws2(:,t) + ((Ss1_t>=Ss0_t).*es2_L_ld(:,t))./(s1_tot + (s1_tot < mass_thresh)*(1)).*ws2_L_ld(:,t);
            ws1(:,t)        = ws1(:,t).*(s1_tot >= mass_thresh) + (-99)*(s1_tot < mass_thresh);


            i_tot      = ei(:,t) + ei2(:,t) + ei_L_ld(:,t) + ei2_L_ld(:,t);
            wi(:,t)         = (ei(:,t))./(i_tot + (i_tot < mass_thresh)*(1)).*wi(:,t)  + (ei_L_ld(:,t))./(i_tot + (i_tot < mass_thresh)*(1)).*wi_L_ld(:,t) ...
                + (ei2(:,t))./(i_tot + (i_tot < mass_thresh)*(1)).*wi2(:,t)  + (ei2_L_ld(:,t))./(i_tot + (i_tot < mass_thresh)*(1)).*wi2_L_ld(:,t);
            wi(:,t)         = wi(:,t).*(i_tot >= mass_thresh) + (-99)*(i_tot < mass_thresh);


            r_tot      = er(:,t) + er2(:,t) + er_L_ld(:,t) + er2_L_ld(:,t);
            wr(:,t)         = (er(:,t))./(r_tot + (r_tot < mass_thresh)*(1)).*wr(:,t)  + (er_L_ld(:,t))./(r_tot + (r_tot < mass_thresh)*(1)).*wr_L_ld(:,t) ...
                + (er2(:,t))./(r_tot + (r_tot < mass_thresh)*(1)).*wr2(:,t) + (er2_L_ld(:,t))./(r_tot + (r_tot < mass_thresh)*(1)).*wr2_L_ld(:,t);
            wr(:,t)         = wr(:,t).*(r_tot >= mass_thresh) + (-99)*(r_tot < mass_thresh);


            wr_L_ld(:,t)    = (-99)*ones(aux.x_grid*aux.alpha_grid,1);

            ws0_L_ld(:,t)   = (-99)*ones(aux.x_grid*aux.alpha_grid,1);
            ws1_L_ld(:,t)   = (-99)*ones(aux.x_grid*aux.alpha_grid,1);

            wi_L_ld(:,t)    = (-99)*ones(aux.x_grid*aux.alpha_grid,1);

            ws2(:,t)        = (-99)*ones(aux.x_grid*aux.alpha_grid,1);
            ws2_L_ld(:,t)   = (-99)*ones(aux.x_grid*aux.alpha_grid,1);

            wi2(:,t)        = (-99)*ones(aux.x_grid*aux.alpha_grid,1);
            wi2_L_ld(:,t)   = (-99)*ones(aux.x_grid*aux.alpha_grid,1);

            wr2(:,t)        = (-99)*ones(aux.x_grid*aux.alpha_grid,1);
            wr2_L_ld(:,t)   = (-99)*ones(aux.x_grid*aux.alpha_grid,1);

            wr_L_ld(:,t)    = (-99)*ones(aux.x_grid*aux.alpha_grid,1);


        end
    end   
    clear s0_tot s1_tot i_tot r_tot
    
    % First incumbents who renegotiate their wage
    
    ws0_incumb = ws0(:,t).*(exp(-aux.dt*param.nu*(Ss_t >=0).*(Ss0_t > Ss1_t))) ... 
         + (1 - exp(-aux.dt*param.nu*(Ss_t >=0).*(Ss0_t > Ss1_t))).* wage_s0(:,grid);
    ws0_incumb = ws0_incumb.*(es0(:,t)>=mass_thresh) - 99*(es0(:,t)< mass_thresh) ; 

    ws1_incumb = ws1(:,t).*(exp(-aux.dt*param.nu*(Ss_t >=0).*(Ss1_t >= Ss0_t))) ... 
         + (1 - exp(-aux.dt*param.nu*(Ss_t >=0).*(Ss1_t >= Ss0_t))).* wage_s1(:,grid);
    ws1_incumb = ws1_incumb.*(es1(:,t)>=mass_thresh) - 99*(es1(:,t)<mass_thresh) ;

    wi_incumb = wi(:,t).*(exp(-aux.dt*param.nu*(Si_t >= 0))) ...
        + (1 - exp(-aux.dt*param.nu*(Si_t >= 0))).* wage_i(:,grid);
    wi_incumb = wi_incumb.*(ei(:,t)>=mass_thresh) - 99*(ei(:,t)<mass_thresh) ;

    wr_incumb = wr(:,t).*(exp(-aux.dt*param.nu*(Sr_t >= 0))) ...
        + (1 - exp(-aux.dt*param.nu*(Sr_t >= 0))).* wage_r(:,grid);
    wr_incumb = wr_incumb.*(er(:,t)>=mass_thresh) - 99*(er(:,t)<mass_thresh) ;

    %%%%%%

    % Updating.
    s0_inc = (es0(:,t) - (1- exp(-aux.dt*(param.delta + param.eta)*es0(:,t))) ...
        - (1- exp(-aux.dt*param.nu*es0(:,t).*(Ss_t < 0))) ...
        - (1- exp(-aux.dt*param.nu*es0(:,t).*(Ss_t >=0).*(Ss1_t >= Ss0_t))) ...
        - (1- exp(-aux.dt*es0(:,t)*param.lambda_0y*ell(t))));
    s0_new = ((1- exp(-aux.dt*us(t)*phi_t*(Ss0_t > Ss1_t).*(Ss_t >= 0).*f)) ... 
        + (1- exp(-aux.dt*param.nu*es1(:,t).*(Ss_t >= 0).*(Ss1_t < Ss0_t))));
    s0_tot = s0_inc + s0_new;
    ws0(:,t+1) = (s0_inc.*ws0_incumb + s0_new.*wage_s0(:,grid))./(s0_tot + (s0_tot < mass_thresh)*(1)).*((s0_tot >= mass_thresh) + (-99)*(s0_tot < mass_thresh));
    ws0(:,t+1) = ws0(:,t+1).*(s0_tot >= mass_thresh) + (-99)*(s0_tot < mass_thresh);    
    clear s0_inc s0_new s0_tot

    s1_inc = (es1(:,t) - (1- exp(-aux.dt*(param.delta + param.eta)*es1(:,t))) ...
        - (1- exp(-aux.dt*param.nu*es1(:,t).*(Ss_t < 0))) ...
        - (1- exp(-aux.dt*param.nu*es1(:,t).*(Ss_t >=0).*(Ss1_t < Ss0_t))) ...
        - (1- exp(-aux.dt*es1(:,t)*(param.lambda_0y + param.lambda_1y)*ell(t))));        
    s1_new = ((1- exp(-aux.dt*us(t)*phi_t*(Ss0_t <= Ss1_t).*(Ss_t >= 0).*f)) ... 
        + (1- exp(-aux.dt*param.nu*es0(:,t).*(Ss_t >= 0).*(Ss1_t >= Ss0_t))));
    s1_tot = s1_inc + s1_new;
    ws1(:,t+1) = (s1_inc.*ws1_incumb + s1_new.*wage_s1(:,grid))./(s1_tot + (s1_tot < mass_thresh)*(1)).*((s1_tot >= mass_thresh) + (-99)*(s1_tot < mass_thresh));
    ws1(:,t+1) = ws1(:,t+1).*(s1_tot >= mass_thresh) + (-99)*(s1_tot < mass_thresh);    
    clear s1_inc s1_new s1_tot

    si_inc = (ei(:,t) - (1- exp(-aux.dt*param.nu*ei(:,t).*(Si_t < 0))) ...
                - (1- exp(-aux.dt*(param.delta + param.rho_y + gamma_y_t + param.eta)*ei(:,t))));      
    si_new = (1- exp(-aux.dt*es0(:,t)*param.lambda_0y*ell(t))) + (1- exp(-aux.dt*es1(:,t).*(param.lambda_0y + param.lambda_1y)*ell(t)));
    si_tot = si_inc + si_new;
    wi(:,t+1) = (si_inc.*wi_incumb + (1- exp(-aux.dt*es0(:,t)*param.lambda_0y*ell(t))).*ws0(:,t) ...
        + (1- exp(-aux.dt*es1(:,t).*(param.lambda_0y + param.lambda_1y)*ell(t))).*ws1(:,t))./(si_tot + (si_tot < mass_thresh)*(1)).*((si_tot >= mass_thresh) + (-99)*(si_tot < mass_thresh)); 
    wi(:,t+1) = wi(:,t+1).*(si_tot >= mass_thresh) + (-99)*(si_tot < mass_thresh);    
    clear si_inc si_new si_tot

    sr_inc = (er(:,t) - (1- exp(-aux.dt*(param.delta + param.eta)*er(:,t))) - (1- exp(-aux.dt*param.nu*er(:,t).*(Sr_t < 0))));
    sr_new = (1- exp(-aux.dt*param.rho_y*ei(:,t))) + (1- exp(-aux.dt*ur(t)*phi_t*(Sr_t >= 0).*f));
    sr_tot = sr_inc + sr_new;
    wr(:,t+1) = (sr_inc.*wr_incumb + (1- exp(-aux.dt*param.rho_y*ei(:,t))).*wi(:,t) ...
        + (1- exp(-aux.dt*ur(t)*phi_t*(Sr_t >= 0).*f)).*wage_r(:,grid))./(sr_tot + (sr_tot < mass_thresh)*(1)).*((sr_tot >= mass_thresh) + (-99)*(sr_tot < mass_thresh)); 
    wr(:,t+1) = wr(:,t+1).*(sr_tot >= mass_thresh) + (-99)*(sr_tot < mass_thresh);   
    clear sr_inc sr_new sr_tot
    
elseif locked(t)==1
    
    if locked(t-1)==0

        ws0_L_ld(:,t) = ws0(:,t);
        ws1_L_ld(:,t) = ws1(:,t);
        wi_L_ld(:,t) = wi(:,t);
        wr_L_ld(:,t) = wr(:,t);

    end
    
            % Incumbent wages 
    ws0_L_ld_incumb = ws0_L_ld(:,t).*(exp(-aux.dt*param.nu*(max(Ss_L_ld_t,Ss2_L_ld_t) >= 0).*(Ss0_L_ld_t > Ss1_L_ld_t & Ss0_L_ld_t >= Ss2_L_ld_t))) ...
        + (1-exp(-aux.dt*param.nu*(max(Ss_L_ld_t,Ss2_L_ld_t) >= 0).*(Ss0_L_ld_t > Ss1_L_ld_t & Ss0_L_ld_t >= Ss2_L_ld_t))).*wage_s0_L_ld(:,grid);
    ws0_L_ld_incumb = ws0_L_ld_incumb.*(es0_L_ld(:,t) >= mass_thresh) - 99*(es0_L_ld(:,t) < mass_thresh);

    ws0_U_ld_incumb = ws0(:,t).*(exp(-aux.dt*param.nu*( max(Ss_U_ld_t,Ss2_U_ld_t) >= 0).*(Ss0_U_ld_t > Ss1_U_ld_t & Ss0_U_ld_t >= Ss2_U_ld_t) )) ...
        + (1-exp(-aux.dt*param.nu*( max(Ss_U_ld_t,Ss2_U_ld_t) >= 0).*(Ss0_U_ld_t > Ss1_U_ld_t & Ss0_U_ld_t >= Ss2_U_ld_t) )).*wage_s0_U_ld(:,grid);
    ws0_U_ld_incumb = ws0_U_ld_incumb.*(es0(:,t) >= mass_thresh) - 99*(es0(:,t) < mass_thresh);

    ws1_L_ld_incumb = ws1_L_ld(:,t).*(exp(-aux.dt*param.nu*(max(Ss_L_ld_t,Ss2_L_ld_t) >= 0).*(Ss1_L_ld_t >= Ss0_L_ld_t & Ss1_L_ld_t >= Ss2_L_ld_t))) ...
        + (1-exp(-aux.dt*param.nu*(max(Ss_L_ld_t,Ss2_L_ld_t) >= 0).*(Ss1_L_ld_t >= Ss0_L_ld_t & Ss1_L_ld_t >= Ss2_L_ld_t))).*wage_s1_L_ld(:,grid);
    ws1_L_ld_incumb = ws1_L_ld_incumb.*(es1_L_ld(:,t) >= mass_thresh) - 99*(es1_L_ld(:,t) < mass_thresh);

    ws1_U_ld_incumb = ws1(:,t).*(exp(-aux.dt*param.nu*( max(Ss_U_ld_t,Ss2_U_ld_t) >= 0).*(Ss1_U_ld_t >= Ss0_U_ld_t & Ss1_U_ld_t >= Ss2_U_ld_t))) ...
        + (1-exp(-aux.dt*param.nu*( max(Ss_U_ld_t,Ss2_U_ld_t) >= 0).*(Ss1_U_ld_t >= Ss0_U_ld_t & Ss1_U_ld_t >= Ss2_U_ld_t))).*wage_s1_U_ld(:,grid);
    ws1_U_ld_incumb = ws1_U_ld_incumb.*(es1(:,t) >= mass_thresh) - 99*(es1(:,t) < mass_thresh);

    ws2_L_ld_incumb = ws2_L_ld(:,t).*(exp(-aux.dt*param.nu*(max(Ss_L_ld_t,Ss2_L_ld_t) >= 0).*(Ss2_L_ld_t > Ss0_L_ld_t & Ss2_L_ld_t > Ss1_L_ld_t))) ...
        + (1-exp(-aux.dt*param.nu*(max(Ss_L_ld_t,Ss2_L_ld_t) >= 0).*(Ss2_L_ld_t > Ss0_L_ld_t & Ss2_L_ld_t > Ss1_L_ld_t))).*wage_s2_L_ld(:,grid);
    ws2_L_ld_incumb = ws2_L_ld_incumb.*(es2_L_ld(:,t) >= mass_thresh) - 99*(es2_L_ld(:,t) < mass_thresh);

    ws2_U_ld_incumb = ws2(:,t).*(exp(-aux.dt*param.nu*( max(Ss_U_ld_t,Ss2_U_ld_t) >= 0).*(Ss2_U_ld_t > Ss0_U_ld_t & Ss2_U_ld_t > Ss1_U_ld_t))) ...
        + (1-exp(-aux.dt*param.nu*( max(Ss_U_ld_t,Ss2_U_ld_t) >= 0).*(Ss2_U_ld_t > Ss0_U_ld_t & Ss2_U_ld_t > Ss1_U_ld_t))).*wage_s2_U_ld(:,grid);
    ws2_U_ld_incumb = ws2_U_ld_incumb.*(es2(:,t) >= mass_thresh) - 99*(es2(:,t) < mass_thresh);

    wi_L_ld_incumb = wi_L_ld(:,t);   
    wi_L_ld_incumb = wi_L_ld_incumb.*(ei_L_ld(:,t) >= mass_thresh) - 99*(ei_L_ld(:,t) < mass_thresh);

    wi_U_ld_incumb = wi(:,t);      
    wi_U_ld_incumb = wi_U_ld_incumb.*(ei(:,t) >= mass_thresh) - 99*(ei(:,t) < mass_thresh);

    wi2_L_ld_incumb = wi2_L_ld(:,t).*(exp(-aux.dt*param.nu*(Si_L_ld_t >=0))) ...       
        + (1- exp(-aux.dt*param.nu*(Si_L_ld_t>=0))).*wage_i2_L_ld(:,grid);         
    wi2_L_ld_incumb = wi2_L_ld_incumb.*(ei2_L_ld(:,t) >= mass_thresh) - 99*(ei2_L_ld(:,t) < mass_thresh);

    wi2_U_ld_incumb = wi2(:,t).*(exp(-aux.dt*param.nu*(Si_U_ld_t>=0))) ...         
        + (1- exp(-aux.dt*param.nu*(Si_U_ld_t>=0))).*wage_i2_U_ld(:,grid);               
    wi2_U_ld_incumb = wi2_U_ld_incumb.*(ei2(:,t) >= mass_thresh) - 99*(ei2(:,t) < mass_thresh);

    wr_L_ld_incumb = wr_L_ld(:,t).*(exp(-aux.dt*param.nu*(max(Sr_L_ld_t,Sr2_L_ld_t) >=0).*(Sr2_L_ld_t <= Sr_L_ld_t))) ...
        + (1- exp(-aux.dt*param.nu*(max(Sr_L_ld_t,Sr2_L_ld_t) >=0).*(Sr2_L_ld_t <= Sr_L_ld_t))).*wage_r_L_ld(:,grid);
    wr_L_ld_incumb = wr_L_ld_incumb.*(er_L_ld(:,t) >= mass_thresh) - 99*(er_L_ld(:,t) < mass_thresh); 

    wr_U_ld_incumb = wr(:,t).*(exp(-aux.dt*param.nu*(max(Sr_U_ld_t,Sr2_U_ld_t) >=0).*( Sr_U_ld_t >= Sr2_U_ld_t ) )) ...
        + (1- exp(-aux.dt*param.nu*(max(Sr_U_ld_t,Sr2_U_ld_t) >=0).*( Sr_U_ld_t >= Sr2_U_ld_t ) )).*wage_r_U_ld(:,grid);
    wr_U_ld_incumb = wr_U_ld_incumb.*(er(:,t) >= mass_thresh) - 99*(er(:,t) < mass_thresh);    

    wr2_L_ld_incumb = wr2_L_ld(:,t).*(exp(-aux.dt*param.nu*(max(Sr_L_ld_t,Sr2_L_ld_t) >=0).*(Sr2_L_ld_t > Sr_L_ld_t))) ...
        + (1- exp(-aux.dt*param.nu*(max(Sr_L_ld_t,Sr2_L_ld_t) >=0).*(Sr2_L_ld_t > Sr_L_ld_t))).*wage_r2_L_ld(:,grid);
    wr2_L_ld_incumb = wr2_L_ld_incumb.*(er2_L_ld(:,t) >= mass_thresh) - 99*(er2_L_ld(:,t) < mass_thresh); 

    wr2_U_ld_incumb = wr2(:,t).*(exp(-aux.dt*param.nu*(max(Sr_U_ld_t,Sr2_U_ld_t) >=0).*(Sr2_U_ld_t > Sr_U_ld_t))) ...
        + (1- exp(-aux.dt*param.nu*(max(Sr_U_ld_t,Sr2_U_ld_t) >=0).*(Sr2_U_ld_t > Sr_U_ld_t))).*wage_r2_U_ld(:,grid);
    wr2_U_ld_incumb = wr2_U_ld_incumb.*(er2(:,t) >= mass_thresh) - 99*(er2(:,t) < mass_thresh); 

    %%%%
    % New guys' wages
    s0_L_ld_inc = (es0_L_ld(:,t)  - (1- exp(-aux.dt*param.delta*es0_L_ld(:,t))) ...
        - (1- exp(-aux.dt*param.eta*es0_L_ld(:,t))) ...
        - (1- exp(-aux.dt*param.nu*es0_L_ld(:,t).*(max(Ss_L_ld_t,Ss2_L_ld_t) < 0))) ...
        - (1- exp(-aux.dt*param.nu*es0_L_ld(:,t).*(max(Ss_L_ld_t,Ss2_L_ld_t) >= 0).*(Ss1_L_ld_t >= Ss0_L_ld_t | Ss2_L_ld_t > Ss0_L_ld_t) )) ...
        - (1- exp(-aux.dt*es0_L_ld(:,t)*param.lambda_0y_ld*ell(t))));
    s0_L_ld_new = (1- exp(-aux.dt*param.pi*us(t)*phi_t*(Ss0_L_ld_t > Ss1_L_ld_t).*(Ss_L_ld_t >= 0).*f)) ...
        + (1- exp(-aux.dt*param.nu*es1_L_ld(:,t).*(max(Ss_L_ld_t,Ss2_L_ld_t) >= 0).*(Ss0_L_ld_t > Ss1_L_ld_t & Ss0_L_ld_t >= Ss2_L_ld_t) ) ) ...
        + (1- exp(-aux.dt*param.nu*es2_L_ld(:,t).*(max(Ss_L_ld_t,Ss2_L_ld_t) >= 0).*(Ss0_L_ld_t > Ss1_L_ld_t & Ss0_L_ld_t >= Ss2_L_ld_t) ) );
    s0_L_ld_tot = s0_L_ld_inc + s0_L_ld_new;
    ws0_L_ld(:,t+1) = (s0_L_ld_inc.*ws0_L_ld_incumb + s0_L_ld_new.*wage_s0_L_ld(:,grid))./(s0_L_ld_tot + (s0_L_ld_tot<mass_thresh)*(1)).* ...
        ((s0_L_ld_tot >= mass_thresh) + (-99)*(s0_L_ld_tot < mass_thresh));
    ws0_L_ld(:,t+1) = ws0_L_ld(:,t+1).*(s0_L_ld_tot >= mass_thresh) + (-99)*(s0_L_ld_tot < mass_thresh);

    clear s0_L_ld_inc s0_L_ld_new s0_L_ld_tot 

    s1_L_ld_inc = (es1_L_ld(:,t) - (1- exp(-aux.dt*param.delta*es1_L_ld(:,t))) ...
        - (1- exp(-aux.dt*param.eta*es1_L_ld(:,t))) ...
        - (1- exp(-aux.dt*param.nu*es1_L_ld(:,t).*(max(Ss_L_ld_t,Ss2_L_ld_t) < 0))) ...
        - (1- exp(-aux.dt*param.nu*es1_L_ld(:,t).*(max(Ss_L_ld_t,Ss2_L_ld_t) >= 0).*(Ss0_L_ld_t > Ss1_L_ld_t | Ss2_L_ld_t > Ss1_L_ld_t) )) ...
        - (1- exp(-aux.dt*es1_L_ld(:,t)*(param.lambda_0y_ld)*ell(t)))); 
    s1_L_ld_new = (1- exp(-aux.dt*param.pi*us(t)*phi_t*(Ss1_L_ld_t >= Ss0_L_ld_t).*(Ss_L_ld_t >= 0).*f)) ...
        + (1- exp(-aux.dt*param.nu*es0_L_ld(:,t).*(max(Ss_L_ld_t,Ss2_L_ld_t) >= 0).*(Ss1_L_ld_t >= Ss0_L_ld_t & Ss1_L_ld_t >= Ss2_L_ld_t) ) ) ...
        + (1- exp(-aux.dt*param.nu*es2_L_ld(:,t).*(max(Ss_L_ld_t,Ss2_L_ld_t) >= 0).*(Ss1_L_ld_t >= Ss0_L_ld_t & Ss1_L_ld_t >= Ss2_L_ld_t) ) );
    s1_L_ld_tot = s1_L_ld_inc + s1_L_ld_new;
    ws1_L_ld(:,t+1) = (s1_L_ld_inc.*ws1_L_ld_incumb + s1_L_ld_new.*wage_s1_L_ld(:,grid))./(s1_L_ld_tot + (s1_L_ld_tot<mass_thresh)*(1)).* ...
        ((s1_L_ld_tot >= mass_thresh) + (-99)*(s1_L_ld_tot < mass_thresh));
    ws1_L_ld(:,t+1) = ws1_L_ld(:,t+1).*(s1_L_ld_tot >= mass_thresh) + (-99)*(s1_L_ld_tot < mass_thresh);

    clear s1_L_ld_inc s1_L_ld_new s1_L_ld_tot 

    s2_L_ld_inc = (es2_L_ld(:,t) - (1- exp(-aux.dt*param.delta*es2_L_ld(:,t))) ...
        - (1- exp(-aux.dt*param.eta*es2_L_ld(:,t))) ...
        - (1- exp(-aux.dt*param.nu*es2_L_ld(:,t).*(max(Ss_L_ld_t,Ss2_L_ld_t) < 0))) ...
        - (1- exp(-aux.dt*param.nu*es2_L_ld(:,t).*(max(Ss_L_ld_t,Ss2_L_ld_t) >= 0).*(Ss0_L_ld_t >= Ss2_L_ld_t | Ss1_L_ld_t >= Ss2_L_ld_t) )) ...
        - (1- exp(-aux.dt*es2_L_ld(:,t)*(param.lambda_0y_ld)*ell(t))));
    s2_L_ld_new = (1- exp(-aux.dt*param.nu*es0_L_ld(:,t).*(max(Ss_L_ld_t,Ss2_L_ld_t) >= 0).*(Ss2_L_ld_t > Ss0_L_ld_t & Ss2_L_ld_t > Ss1_L_ld_t) ) ) ...
        + (1- exp(-aux.dt*param.nu*es1_L_ld(:,t).*(max(Ss_L_ld_t,Ss2_L_ld_t) >= 0).*(Ss2_L_ld_t > Ss0_L_ld_t & Ss2_L_ld_t > Ss1_L_ld_t) ) );
    s2_L_ld_tot = s2_L_ld_inc + s2_L_ld_new;
    ws2_L_ld(:,t+1) = (s2_L_ld_inc.*ws2_L_ld_incumb + s2_L_ld_new.*wage_s2_L_ld(:,grid))./(s2_L_ld_tot + (s2_L_ld_tot<mass_thresh)*(1)).* ...
        ((s2_L_ld_tot >= mass_thresh) + (-99)*(s2_L_ld_tot < mass_thresh));
    ws2_L_ld(:,t+1) = ws2_L_ld(:,t+1).*(s2_L_ld_tot >= mass_thresh) + (-99)*(s2_L_ld_tot < mass_thresh);

    clear s2_L_ld_inc s2_L_ld_new s2_L_ld_tot

    s0_U_ld_inc = (es0(:,t)  - (1- exp(-aux.dt*param.delta*es0(:,t))) ...
        - (1- exp(-aux.dt*param.eta*es0(:,t))) ...
        - (1- exp(-aux.dt*param.nu*es0(:,t).*( max(Ss_U_ld_t,Ss2_U_ld_t) < 0))) ...
        - (1- exp(-aux.dt*param.nu*es0(:,t).*( max(Ss_U_ld_t,Ss2_U_ld_t) >= 0).*(Ss1_U_ld_t >= Ss0_U_ld_t | Ss2_U_ld_t > Ss0_U_ld_t) )) ...
        - (1- exp(-aux.dt*es0(:,t)*param.lambda_0y_ld*ell(t))));
    s0_U_ld_new = (1- exp(-aux.dt*(1-param.pi)*us(t)*phi_t*(Ss0_U_ld_t > Ss1_U_ld_t).*(Ss_U_ld_t >= 0).*f)) ...
        + (1- exp(-aux.dt*param.nu*es1(:,t).*( max(Ss_U_ld_t,Ss2_U_ld_t) >= 0).*(Ss0_U_ld_t > Ss1_U_ld_t & Ss0_U_ld_t >= Ss2_U_ld_t) ) ) ...
        + (1- exp(-aux.dt*param.nu*es2(:,t).*( max(Ss_U_ld_t,Ss2_U_ld_t) >= 0).*(Ss0_U_ld_t > Ss1_U_ld_t & Ss0_U_ld_t >= Ss2_U_ld_t) ) );
    s0_U_ld_tot = s0_U_ld_inc + s0_U_ld_new;
    ws0(:,t+1) = (s0_U_ld_inc.*ws0_U_ld_incumb + s0_U_ld_new.*wage_s0_U_ld(:,grid))./(s0_U_ld_tot + (s0_U_ld_tot<mass_thresh)*(1)).* ...
        ((s0_U_ld_tot >= mass_thresh) + (-99)*(s0_U_ld_tot < mass_thresh));
    ws0(:,t+1) = ws0(:,t+1).*(s0_U_ld_tot >= mass_thresh) + (-99)*(s0_U_ld_tot < mass_thresh);

    clear s0_U_ld_inc s0_U_ld_new s0_U_ld_tot 

    s1_U_ld_inc = (es1(:,t) - (1- exp(-aux.dt*param.delta*es1(:,t))) ...
        - (1- exp(-aux.dt*param.eta*es1(:,t))) ...
        - (1- exp(-aux.dt*param.nu*es1(:,t).*( max(Ss_U_ld_t,Ss2_U_ld_t) < 0))) ...
        - (1- exp(-aux.dt*param.nu*es1(:,t).*( max(Ss_U_ld_t,Ss2_U_ld_t) >= 0).*(Ss0_U_ld_t > Ss1_U_ld_t | Ss2_U_ld_t > Ss1_U_ld_t) )) ...
        - (1- exp(-aux.dt*es1(:,t)*param.lambda_0y_ld*ell(t))) ...
        - (1- exp(-aux.dt*es1(:,t)*param.lambda_1y*ell(t))));
    s1_U_ld_new = (1- exp(-aux.dt*(1-param.pi)*us(t)*phi_t*(Ss1_U_ld_t >= Ss0_U_ld_t).*(Ss_U_ld_t >= 0).*f)) ...
        + (1- exp(-aux.dt*param.nu*es0(:,t).*( max(Ss_U_ld_t,Ss2_U_ld_t) >= 0).*(Ss1_U_ld_t >= Ss0_U_ld_t & Ss1_U_ld_t >= Ss2_U_ld_t) ) ) ...
        + (1- exp(-aux.dt*param.nu*es2(:,t).*( max(Ss_U_ld_t,Ss2_U_ld_t) >= 0).*(Ss1_U_ld_t >= Ss0_U_ld_t & Ss1_U_ld_t >= Ss2_U_ld_t) ) );
    s1_U_ld_tot = s1_U_ld_inc + s1_U_ld_new;
    ws1(:,t+1) = (s1_U_ld_inc.*ws1_U_ld_incumb + s1_U_ld_new.*wage_s1_U_ld(:,grid))./(s1_U_ld_tot + (s1_U_ld_tot<mass_thresh)*(1)).* ...
        ((s1_U_ld_tot >= mass_thresh) + (-99)*(s1_U_ld_tot < mass_thresh));
    ws1(:,t+1) = ws1(:,t+1).*(s1_U_ld_tot >= mass_thresh) + (-99)*(s1_U_ld_tot < mass_thresh);

    clear s1_U_ld_inc s1_U_ld_new s1_U_ld_tot 

    s2_U_ld_inc = (es2(:,t) - (1- exp(-aux.dt*param.delta*es2(:,t))) ...
        - (1- exp(-aux.dt*param.eta*es2(:,t))) ...
        - (1- exp(-aux.dt*param.nu*es2(:,t).*( max(Ss_U_ld_t,Ss2_U_ld_t) < 0))) ...
        - (1- exp(-aux.dt*param.nu*es2(:,t).*( max(Ss_U_ld_t,Ss2_U_ld_t) >= 0).*(Ss0_U_ld_t >= Ss2_U_ld_t | Ss1_U_ld_t >= Ss2_U_ld_t) )) ...
        - (1- exp(-aux.dt*es2(:,t)*(param.lambda_0y_ld)*ell(t))));
    s2_U_ld_new = (1- exp(-aux.dt*param.nu*es0(:,t).*( max(Ss_U_ld_t,Ss2_U_ld_t) >= 0).*(Ss2_U_ld_t > Ss0_U_ld_t & Ss2_U_ld_t > Ss1_U_ld_t) ) ) ...
        + (1- exp(-aux.dt*param.nu*es1(:,t).*( max(Ss_U_ld_t,Ss2_U_ld_t) >= 0).*(Ss2_U_ld_t > Ss0_U_ld_t & Ss2_U_ld_t > Ss1_U_ld_t) ) );
    s2_U_ld_tot = s2_U_ld_inc + s2_U_ld_new;
    ws2(:,t+1) = (s2_U_ld_inc.*ws2_U_ld_incumb + s2_U_ld_new.*wage_s2_U_ld(:,grid))./(s2_U_ld_tot + (s2_U_ld_tot<mass_thresh)*(1)).* ...
        ((s2_U_ld_tot >= mass_thresh) + (-99)*(s2_U_ld_tot < mass_thresh));
    ws2(:,t+1) = ws2(:,t+1).*(s2_U_ld_tot >= mass_thresh) + (-99)*(s2_U_ld_tot < mass_thresh);

    clear s2_U_ld_inc s2_U_ld_new s2_U_ld_tot 

    si_L_ld_inc = (ei_L_ld(:,t)  - (1- exp(-aux.dt*param.delta*ei_L_ld(:,t))) ...
         - (1- exp(-aux.dt*param.rho_y*ei_L_ld(:,t))) ...
         - (1- exp(-aux.dt*gamma_y_t*ei_L_ld(:,t))) ...
         - (1- exp(-aux.dt*param.eta*ei_L_ld(:,t))) ...
         - (1- exp(-aux.dt*param.nu*ei_L_ld(:,t))));
    si_L_ld_new = (1- exp(-aux.dt*es0_L_ld(:,t)*param.lambda_0y_ld*ell(t))) ...
         + (1- exp(-aux.dt*es1_L_ld(:,t)*param.lambda_0y_ld*ell(t)));
    si_L_ld_tot = si_L_ld_inc + si_L_ld_new;
    wi_L_ld(:,t+1) = (si_L_ld_inc.*wi_L_ld_incumb + (1- exp(-aux.dt*es0_L_ld(:,t)*param.lambda_0y_ld*ell(t))).*ws0_L_ld(:,t) ...
        + (1- exp(-aux.dt*es1_L_ld(:,t)*param.lambda_0y_ld*ell(t))).*ws1_L_ld(:,t))./(si_L_ld_tot + (si_L_ld_tot < mass_thresh)*(1)).* ...
        ((si_L_ld_tot >= mass_thresh) + (-99)*(si_L_ld_tot < mass_thresh));
    wi_L_ld(:,t+1) = wi_L_ld(:,t+1).*(si_L_ld_tot >= mass_thresh) + (-99)*(si_L_ld_tot < mass_thresh);

    clear si_L_ld_inc si_L_ld_new si_L_ld_tot

    si2_L_ld_inc = (ei2_L_ld(:,t) - (1- exp(-aux.dt*param.delta*ei2_L_ld(:,t))) ...
        - (1- exp(-aux.dt*param.rho_y*ei2_L_ld(:,t))) ...
        - (1- exp(-aux.dt*gamma_y_t*ei2_L_ld(:,t))) ...
        - (1- exp(-aux.dt*param.eta*ei2_L_ld(:,t))) ...
        - (1- exp(-aux.dt*param.nu*ei2_L_ld(:,t).*(Si_L_ld_t<0) ))); 
    si2_L_ld_new = (1- exp(-aux.dt*es2_L_ld(:,t)*param.lambda_0y_ld*ell(t))) ...
        + (1- exp(-aux.dt*param.nu*ei_L_ld(:,t).*(Si_L_ld_t>=0) )) ;  
    si2_L_ld_tot = si2_L_ld_inc + si2_L_ld_new;
    wi2_L_ld(:,t+1) = (si2_L_ld_inc.*wi2_L_ld_incumb + (1- exp(-aux.dt*es2_L_ld(:,t)*param.lambda_0y_ld*ell(t))).*ws2_L_ld(:,t) ... 
        + (1- exp(-aux.dt*param.nu*ei_L_ld(:,t).*(Si_L_ld_t>=0) )).*wage_i2_L_ld(:,grid))./(si2_L_ld_tot + (si2_L_ld_tot < mass_thresh)*(1)).* ...
        ((si2_L_ld_tot >= mass_thresh) + (-99)*(si2_L_ld_tot < mass_thresh));
    wi2_L_ld(:,t+1) = wi2_L_ld(:,t+1).*(si2_L_ld_tot >= mass_thresh) + (-99)*(si2_L_ld_tot < mass_thresh);

    clear si2_L_ld_inc si2_L_ld_new si2_L_ld_tot

    si_U_ld_inc = (ei(:,t) - (1- exp(-aux.dt*param.delta*ei(:,t))) ...
         - (1- exp(-aux.dt*param.rho_y*ei(:,t))) ...
         - (1- exp(-aux.dt*gamma_y_t*ei(:,t))) ...
         - (1- exp(-aux.dt*param.eta*ei(:,t))) ...
         - (1- exp(-aux.dt*param.nu*ei(:,t))));
    si_U_ld_new = (1- exp(-aux.dt*es0(:,t)*param.lambda_0y_ld*ell(t))) ...
             + (1- exp(-aux.dt*es1(:,t)*param.lambda_0y_ld*ell(t))) ...
             + (1- exp(-aux.dt*es1(:,t)*param.lambda_1y*ell(t)));
    si_U_ld_tot = si_U_ld_inc + si_U_ld_new;
    wi(:,t+1) = (si_U_ld_inc.*wi_U_ld_incumb + (1- exp(-aux.dt*es0(:,t)*param.lambda_0y_ld*ell(t))).*ws0(:,t) ...
        + (1- exp(-aux.dt*es1(:,t)*param.lambda_0y_ld*ell(t))).*ws1(:,t) ...
        + (1- exp(-aux.dt*es1(:,t)*param.lambda_1y*ell(t))).*ws1(:,t))./(si_U_ld_tot + (si_U_ld_tot < mass_thresh)*(1)).* ...
        ((si_U_ld_tot >= mass_thresh) + (-99)*(si_U_ld_tot < mass_thresh));
    wi(:,t+1) = wi(:,t+1).*(si_U_ld_tot >= mass_thresh) + (-99)*(si_U_ld_tot < mass_thresh);

    clear si_L_ld_inc si_L_ld_new si_L_ld_tot

    si2_U_ld_inc = (ei2(:,t) - (1- exp(-aux.dt*param.delta*ei2(:,t))) ...
        - (1- exp(-aux.dt*param.rho_y*ei2(:,t))) ...
        - (1- exp(-aux.dt*gamma_y_t*ei2(:,t))) ...
        - (1- exp(-aux.dt*param.eta*ei2(:,t))) ...
        - (1- exp(-aux.dt*param.nu*ei2(:,t).*(Si_U_ld_t < 0))));
    si2_U_ld_new = (1- exp(-aux.dt*es2(:,t)*(param.lambda_0y_ld)*ell(t))) ...
        + (1- exp(-aux.dt*param.nu*ei(:,t).*(Si_U_ld_t>=0))); 
    si2_U_ld_tot = si2_U_ld_inc + si2_U_ld_new;
    wi2(:,t+1) = (si2_U_ld_inc.*wi2_U_ld_incumb + (1- exp(-aux.dt*es2(:,t)*(param.lambda_0y_ld)*ell(t))).*ws2(:,t) ...
        + (1- exp(-aux.dt*param.nu*ei(:,t).*(Si_U_ld_t>=0))).*wage_i2_U_ld(:,grid))./(si2_U_ld_tot + (si2_U_ld_tot < mass_thresh)*(1)).* ...
        ((si2_U_ld_tot >= mass_thresh) + (-99)*(si2_U_ld_tot < mass_thresh));
    wi2(:,t+1) = wi2(:,t+1).*(si2_U_ld_tot >= mass_thresh) + (-99)*(si2_U_ld_tot < mass_thresh);

    clear si2_L_ld_inc si2_L_ld_new si2_L_ld_tot


    sr_L_ld_inc = (er_L_ld(:,t) - (1- exp(-aux.dt*param.delta*er_L_ld(:,t))) ...
        - (1- exp(-aux.dt*param.eta*er_L_ld(:,t))) ...
        - (1- exp(-aux.dt*param.nu*er_L_ld(:,t) .*(max(Sr_L_ld_t,Sr2_L_ld_t) < 0))) ...
        - (1- exp(-aux.dt*param.nu*er_L_ld(:,t) .*(max(Sr_L_ld_t,Sr2_L_ld_t) >=0).*(Sr2_L_ld_t > Sr_L_ld_t))));
    sr_L_ld_new = (1- exp(-aux.dt*ur(t)*param.pi*phi_t*(Sr_L_ld_t >= 0).*f)) ...
        + (1- exp(-aux.dt*param.rho_y*(ei_L_ld(:,t)).*(Sr_L_ld_t >= Sr2_L_ld_t) )) ... 
        + (1- exp(-aux.dt*param.rho_y*(ei2_L_ld(:,t)).*(Sr_L_ld_t >= Sr2_L_ld_t) )) ... 
        + (1- exp(-aux.dt*param.nu*er2_L_ld(:,t).*(max(Sr_L_ld_t,Sr2_L_ld_t) >=0).*(Sr2_L_ld_t <= Sr_L_ld_t) )) ; 
    sr_L_ld_tot = sr_L_ld_inc + sr_L_ld_new;
    wr_L_ld(:,t+1) = (sr_L_ld_inc.*wr_L_ld_incumb + (1- exp(-aux.dt*ur(t)*param.pi*phi_t*(Sr_L_ld_t >= 0).*f)).*wage_r_L_ld(:,grid) ...
        + (1- exp(-aux.dt*param.rho_y*(ei_L_ld(:,t)).*(Sr_L_ld_t >= Sr2_L_ld_t) )).*wi_L_ld(:,t) ...
        + (1- exp(-aux.dt*param.rho_y*(ei2_L_ld(:,t)).*(Sr_L_ld_t >= Sr2_L_ld_t) )).*wi2_L_ld(:,t) ...
        + (1- exp(-aux.dt*param.nu*er2_L_ld(:,t).*(max(Sr_L_ld_t,Sr2_L_ld_t) >=0).*(Sr2_L_ld_t <= Sr_L_ld_t) )).*wage_r_L_ld(:,grid))./(sr_L_ld_tot + (sr_L_ld_tot < mass_thresh)*(1)).* ...
        ((sr_L_ld_tot >= mass_thresh) + (-99)*(sr_L_ld_tot < mass_thresh));
    wr_L_ld(:,t+1) = wr_L_ld(:,t+1).*(sr_L_ld_tot >= mass_thresh) + (-99)*(sr_L_ld_tot < mass_thresh);

    clear sr_L_ld_inc sr_L_Ld_new sr_L_ld_tot

    sr2_L_ld_inc = (er2_L_ld(:,t) - (1- exp(-aux.dt*param.delta*er2_L_ld(:,t))) ...
        - (1- exp(-aux.dt*param.eta*er2_L_ld(:,t))) ...
        - (1- exp(-aux.dt*param.nu*er2_L_ld(:,t).*(max(Sr_L_ld_t,Sr2_L_ld_t) < 0))) ...
        - (1- exp(-aux.dt*param.nu*er2_L_ld(:,t).*(max(Sr_L_ld_t,Sr2_L_ld_t) >=0).*(Sr2_L_ld_t <= Sr_L_ld_t))));
    sr2_L_ld_new = (1- exp(-aux.dt*param.rho_y*(ei_L_ld(:,t)).*(Sr_L_ld_t < Sr2_L_ld_t) )) ...
        + (1- exp(-aux.dt*param.rho_y*(ei2_L_ld(:,t)).*(Sr_L_ld_t < Sr2_L_ld_t) )) ...
        + (1- exp(-aux.dt*param.nu*er_L_ld(:,t).*(max(Sr_L_ld_t,Sr2_L_ld_t) >=0).*(Sr2_L_ld_t > Sr_L_ld_t))) ; 
    sr2_L_ld_tot = sr2_L_ld_inc + sr2_L_ld_new;
    wr2_L_ld(:,t+1) = (sr2_L_ld_inc.*wr2_L_ld_incumb + (1- exp(-aux.dt*param.rho_y*(ei_L_ld(:,t)).*(Sr_L_ld_t < Sr2_L_ld_t) )).*wi_L_ld(:,t) ...
        + (1- exp(-aux.dt*param.rho_y*(ei2_L_ld(:,t)).*(Sr_L_ld_t < Sr2_L_ld_t) )).*wi2_L_ld(:,t) ...
        + (1- exp(-aux.dt*param.nu*er_L_ld(:,t).*(max(Sr_L_ld_t,Sr2_L_ld_t) >=0).*(Sr2_L_ld_t > Sr_L_ld_t))).*wage_r2_L_ld(:,grid))./(sr2_L_ld_tot + (sr2_L_ld_tot < mass_thresh)*(1)).* ...
        ((sr2_L_ld_tot >= mass_thresh) + (-99)*(sr2_L_ld_tot < mass_thresh));
    wr2_L_ld(:,t+1) = wr2_L_ld(:,t+1).*(sr2_L_ld_tot >= mass_thresh) + (-99)*(sr2_L_ld_tot < mass_thresh);

    clear sr2_L_ld_inc sr2_L_Ld_new sr2_L_ld_tot

    sr_U_ld_inc = (er(:,t) - (1- exp(-aux.dt*param.delta*er(:,t))) ...
        - (1- exp(-aux.dt*param.eta*er(:,t))) ...
        - (1- exp(-aux.dt*param.nu*er(:,t) .*(max(Sr_U_ld_t,Sr2_U_ld_t) < 0))) ...
        - (1- exp(-aux.dt*param.nu*er(:,t) .*(max(Sr_U_ld_t,Sr2_U_ld_t) >=0).*(Sr2_U_ld_t > Sr_U_ld_t)   )));
    sr_U_ld_new = (1- exp(-aux.dt*ur(t)*(1-param.pi)*phi_t*(Sr_U_ld_t >= 0).*f)) ...
        + (1- exp(-aux.dt*param.rho_y*(ei(:,t)).*(Sr_U_ld_t >= Sr2_U_ld_t) )) ...
        + (1- exp(-aux.dt*param.rho_y*(ei2(:,t)).*(Sr_U_ld_t >= Sr2_U_ld_t) )) ...
        + (1- exp(-aux.dt*param.nu*er2(:,t).*(max(Sr_U_ld_t,Sr2_U_ld_t) >=0).*( Sr_U_ld_t >= Sr2_U_ld_t ) )); 
    sr_U_ld_tot = sr_U_ld_inc + sr_U_ld_new;
    wr(:,t+1) = (sr_U_ld_inc.*wr_U_ld_incumb + (1- exp(-aux.dt*ur(t)*(1-param.pi)*phi_t*(Sr_U_ld_t >= 0).*f)).*wage_r_U_ld(:,grid) ...
        + (1- exp(-aux.dt*param.rho_y*(ei(:,t)).*(Sr_U_ld_t >= Sr2_U_ld_t) )).*wi(:,t) ...
        + (1- exp(-aux.dt*param.rho_y*(ei2(:,t)).*(Sr_U_ld_t >= Sr2_U_ld_t) )).*wi2(:,t) ...
        + (1- exp(-aux.dt*param.nu*er2(:,t).*(max(Sr_U_ld_t,Sr2_U_ld_t) >=0).*( Sr_U_ld_t >= Sr2_U_ld_t ) )).*wage_r_U_ld(:,grid))./(sr_U_ld_tot + (sr_U_ld_tot < mass_thresh)*(1)).* ...
        ((sr_U_ld_tot >= mass_thresh) + (-99)*(sr_U_ld_tot < mass_thresh));
    wr(:,t+1) = wr(:,t+1).*(sr_U_ld_tot >= mass_thresh) + (-99)*(sr_U_ld_tot < mass_thresh);

    clear sr_U_ld_inc sr_U_Ld_new sr_U_ld_tot

    sr2_U_ld_inc = (er2(:,t) - (1- exp(-aux.dt*param.delta*er2(:,t))) ...
        - (1- exp(-aux.dt*param.eta*er2(:,t))) ...
        - (1- exp(-aux.dt*param.nu*er2(:,t).*(max(Sr_U_ld_t,Sr2_U_ld_t) < 0))) ...
        - (1- exp(-aux.dt*param.nu*er2(:,t).*(max(Sr_U_ld_t,Sr2_U_ld_t) >=0).*( Sr_U_ld_t >= Sr2_U_ld_t ) )) );
    sr2_U_ld_new = (1- exp(-aux.dt*param.rho_y*(ei(:,t)).*(Sr2_U_ld_t > Sr_U_ld_t ) )) ...
        + (1- exp(-aux.dt*param.rho_y*(ei2(:,t)).*(Sr2_U_ld_t > Sr_U_ld_t ) )) ...
        + (1- exp(-aux.dt*param.nu*er(:,t) .*(max(Sr_U_ld_t,Sr2_U_ld_t) >=0).*(Sr2_U_ld_t > Sr_U_ld_t)   )) ; 
    sr2_U_ld_tot = sr2_U_ld_inc + sr2_U_ld_new;
    wr2(:,t+1) = (sr2_U_ld_inc.*wr2_U_ld_incumb + (1- exp(-aux.dt*param.rho_y*(ei(:,t)).*(Sr2_U_ld_t > Sr_U_ld_t ) )).*wage_r2_U_ld(:,grid) ...
        + (1- exp(-aux.dt*param.rho_y*(ei2(:,t)).*(Sr2_U_ld_t > Sr_U_ld_t ) )).*wi2(:,t) ...
        + (1- exp(-aux.dt*param.nu*er(:,t) .*(max(Sr_U_ld_t,Sr2_U_ld_t) >=0).*(Sr2_U_ld_t > Sr_U_ld_t)   )) .*wage_r2_U_ld(:,grid))./(sr2_U_ld_tot + (sr2_U_ld_tot < mass_thresh)*(1)).* ...
        ((sr2_U_ld_tot >= mass_thresh) + (-99)*(sr2_U_ld_tot < mass_thresh));
    wr2(:,t+1) = wr2(:,t+1).*(sr2_U_ld_tot >= mass_thresh) + (-99)*(sr2_U_ld_tot < mass_thresh);

    clear sr2_U_ld_inc sr2_U_Ld_new sr2_U_ld_tot

    
end